#include <X11/Xlib.h>
#include <string.h>

#define WINDOW_W   400      /* ɥ */
#define WINDOW_H   300      /* ɥι⤵ */
#define BORDER     2        /* ܡ */
#define MOVEB_W    70       /* ưܥ */
#define MOVEB_H    30       /* ưܥι⤵ */
#define RESIZEB_W  MOVEB_W  /* ѹܥ */
#define RESIZEB_H  MOVEB_H  /* ѹܥι⤵ */


static Display*       dpy;              /* ǥץ쥤 */
static int            screen;           /* ꡼ */
static Window         root;             /* 롼ȥɥ */
static unsigned long  black, white;     /* Υԥ */
static GC             gc;               /* եåƥ */
static Window         win;              /* ɽ륦ɥ */
static Window         move_b, resize_b; /* ܥѥɥ */
static int            x = 100, y = 100; /* win ΰֺɸ */


static void xctrl_init( void );
static void xctrl_create_window( void );
static void xctrl_event_loop( void );
static void xctrl_proc_moveb( void );
static void xctrl_proc_resizeb( void );


int 
main( void )
{
	/*  */
	xctrl_init();

	/* ɥ */
	xctrl_create_window();

	/* ͤδĶǤ XCreateSimpleWindow() κɸǤϻ̤ΰ
	   ɽʤΤǡޥåפ˰ٰưƤ */
	XMapWindow( dpy, win );
	XMoveWindow( dpy, win, x, y );

	/* winƥɥȤƤλҥɥޥåפ */
	XMapSubwindows( dpy, win );

	/* ٥ȥ롼 */
	xctrl_event_loop();

	return 0;
}


static void 
xctrl_init( void )
{
	dpy = XOpenDisplay( "" );

	root   = DefaultRootWindow( dpy );
	screen = DefaultScreen( dpy );

	white = WhitePixel( dpy, screen );
	black = BlackPixel( dpy, screen );
}


static void 
xctrl_create_window( void )
{
	win = XCreateSimpleWindow( dpy, root, 100, 100, 
		   WINDOW_W, WINDOW_H, BORDER, black, white );

	move_b = XCreateSimpleWindow( dpy, win, 10, 10, 
		      MOVEB_W, MOVEB_H, BORDER, black, white );

	resize_b = XCreateSimpleWindow( dpy, win, 10 + MOVEB_W + 5, 10, 
		RESIZEB_W, RESIZEB_H, BORDER, black, white );

	gc = XCreateGC( dpy, win, 0, NULL );
	XSetBackground( dpy, gc, white );
	XSetForeground( dpy, gc, black );

	XSelectInput( dpy, win,      ExposureMask    | KeyPressMask );
	XSelectInput( dpy, move_b,   ButtonPressMask | ExposureMask );
	XSelectInput( dpy, resize_b, ButtonPressMask | ExposureMask );
}


static void
xctrl_event_loop( void )
{
	XEvent event;

	while( 1 ) {
		XNextEvent( dpy, &event );
		switch( event.type ) {
			case Expose:
				if ( event.xexpose.count == 0 ) {
					/* ܥΥ٥ */
					XDrawString( dpy, move_b, gc, 
					    15, MOVEB_H / 2, "MOVE", 
					    strlen( "MOVE" ) );

					XDrawString( dpy, resize_b, gc, 
					    15, RESIZEB_H / 2, "RESIZE", 
					    strlen( "RESIZE" ) );
				}
				break;

			case ButtonPress:
				/* ưܥ */
				if ( event.xbutton.window == move_b  ) {
					xctrl_proc_moveb();
				}

				/* ѹܥ */
				else if ( event.xbutton.window == resize_b ) {
					xctrl_proc_resizeb();
				}	    

				break;

			case KeyPress:
				XFreeGC( dpy, gc );
				XDestroyWindow( dpy, win );
				XCloseDisplay( dpy );
				return;
		}
	}
}


static void 
xctrl_proc_moveb()
{
	/* ɥޥ͡㤬֤ˤ뤿ᤫXGetGeometry() Ǥ
	   ֤ǤʤäΤǸߺɸ̤¸ƤȤˤơ
	   ȤƥɥưƤޤ */

	x += 10;
	y += 10;
	
	XMoveWindow( dpy, win, x, y );
}


static void 
xctrl_proc_resizeb( void )
{
	static int stat = 0;

	unsigned int w, h;
	unsigned int dummy;


	/* ߤȹ⤵ */
	XGetGeometry( dpy, win, (Window*)&dummy, (int*)&dummy, (int*)&dummy, 
		      &w, &h, &dummy, &dummy );

	if ( ! stat ) {
		/*  */
		w    *= 2;
		h    *= 2;
		stat  = 1;
	}
	else {
		/* ̾ */
		w    /= 2;
		h    /= 2;
		stat  = 0;
	}

	XResizeWindow( dpy, win, w, h );
}

/* End of xctrl.c */
