#include <X11/Xlib.h>
#include <X11/Xlocale.h> /* ѥإåե */
#include <stdio.h>
#include <string.h>

#define WIN_W  350  /* ɥ   */
#define WIN_H  250  /* ɥι⤵ */
#define WIN_X  100  /* ɥɽ(X) */
#define WIN_Y  100  /* ɥɽ(Y) */
#define BORDER 2    /* ܡ */


int
main( void )
{
	Display*      dpy;            /* ǥץ쥤ѿ */
	Window        root;           /* 롼ȥɥ */
	Window        win;            /* ɽ륦ɥ */
	int           screen;         /* ꡼ */
	unsigned long black,white;    /* Υԥ */
	GC            gc;             /* եåƥ */
	XEvent        evt;            /* ٥ȹ¤ */

	XFontSet      fs;             /* եȥå */
	int           missing_count;  /* ¸ߤʤʸο */
	char**        missing_list;   /* ¸ߤʤʸ */
	char*         def_string;     /* Ф褵ʸ */


	/* 褹ʸ */
	char*         string = "ˤϡǤ";


	/* ꤹ(ߥƥꤵƤ) */
	if ( setlocale( LC_CTYPE, "" ) == NULL ) {
		printf( "Can't set locale\n" );
		return 1;
	}

	/* Xlib ߤΥ򰷤뤫ɤȽǤ */
	if ( ! XSupportsLocale() ) {
		printf( "Current locale is not supported\n" );
		return 1;
	}


	dpy = XOpenDisplay( "" );

	root   = DefaultRootWindow( dpy );
	screen = DefaultScreen( dpy );
	white  = WhitePixel( dpy, screen );
	black  = BlackPixel( dpy, screen );


	win = XCreateSimpleWindow( dpy, root,
		   WIN_X, WIN_Y, WIN_W, WIN_H, BORDER, black, white );


	gc = XCreateGC( dpy, win, 0, NULL );
	XSetBackground( dpy, gc, white );
	XSetForeground( dpy, gc, black );


	/* եȥåȤ */
	fs = XCreateFontSet( dpy, "-*-fixed-medium-r-normal--16-*-*-*", 
			     &missing_list, &missing_count, &def_string );

	if ( fs == NULL ) {
		printf( "Failed to create fontset\n" );
		return 1;
	}

	XFreeStringList( missing_list );

	XSelectInput( dpy, win, ExposureMask | KeyPressMask );
	XMapWindow( dpy, win );


	while( 1 ) {
		XNextEvent( dpy, &evt );

		switch( evt.type ) {
			case Expose:
				if( evt.xexpose.count == 0 ) {
					XmbDrawString( dpy, win, fs, gc, 
						50, 50, string, strlen( string ) );
				}
				break;

			case KeyPress:
				XFreeGC( dpy, gc );
				XFreeFontSet( dpy, fs );
				XDestroyWindow( dpy, win );
				XCloseDisplay( dpy );
				return 0;
		}
	}
}

/* End of xmbcs.c */

