/*
 *  off-the-spot (Խʸ򥯥饤Ȥθΰ
 *  ɽ륿)Υץץ
 */

#include <X11/Xlib.h>
#include <X11/Xlocale.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdio.h>


#define BORDER  2    /* ܡ */
#define COL     30   /* 30 */
#define ROW     20   /* 20 */

static Display*          dpy;          /* ǥץ쥤 */
static int               screen;       /* ꡼ */
static Window            root;         /* 롼ȥɥ */
static Window            win;          /* ɽ륦ɥ */
static int               win_w, win_h; /* ɥȹ⤵ */
static unsigned long     black, white; /* Υԥ */
static GC                gc;           /* եåƥ */
static XFontSet          fs;           /* եȥå */
static int               font_w;       /* ʸ */
static int               font_h;       /* ʸ */
static int               ascent;       /* ʸΥ */
static int               descent;      /* ʸΥǥ */
static XIM               im;           /* ץåȥ᥽å */
static XIC               ic;           /* ץåȥƥ */
static Atom              protocol;     /* ɥޥ͡ѿ */


static int  xim_setlocale();
static void xim_init();
static void xim_create_fontset();
static void xim_create_window();
static int  xim_init_inputmethod();
static void xim_event_loop();
static void xim_draw( XEvent* event );
static void xim_close();


int 
main( void )
{
	/* ץåȥ᥽åɤɬפȤ륤٥ */
	unsigned long fevent;

	if ( xim_setlocale() == -1 ) {
		return 1;
	}

	xim_init();
	xim_create_fontset();
	xim_create_window();

	/* ץåȥ᥽åɤν */
	if ( xim_init_inputmethod() == -1 ) {
		return 1;
	}

	/* ɥ˲٥Ȥ */
	protocol = XInternAtom( dpy, "WM_DELETE_WINDOW", True );
	XSetWMProtocols( dpy, win, &protocol, 1 );

	/* ץåȥ᥽åɤɬפȤ륤٥Ȥ䤤碌 */
	XGetICValues( ic, XNFilterEvents, &fevent, NULL );

	XSelectInput( dpy, win, 
	      ExposureMask | KeyPressMask | FocusChangeMask | fevent );
	XMapWindow( dpy, win );

	xim_event_loop();
	xim_close();

	return 0;
}


static int 
xim_setlocale( void )
{
	if ( setlocale( LC_CTYPE, "" ) == NULL ) {
		printf( "Can't set locale.\n" );
		return -1;
	}

	if ( ! XSupportsLocale() ) {
		printf( "Current locale is not supported\n" );
		return -1;
	}

	/* 桼ΥǥեϢ뤹 */
	if ( XSetLocaleModifiers( "" ) == NULL ) {
		printf( "Can't set locale modifiers\n" );
		return -1;
	}

	return 0;
}


static void 
xim_init( void )
{
	dpy = XOpenDisplay( "" );

	root   = DefaultRootWindow( dpy );
	screen = DefaultScreen( dpy );
	white  = WhitePixel( dpy, screen );
	black  = BlackPixel( dpy, screen );
}


static void 
xim_create_fontset( void )
{
	XFontSetExtents*  fs_extents;
	int    missing_count;
	char** missing_list;
	char*  def_string;

	fs = XCreateFontSet( dpy, "-*-fixed-medium-r-normal--14-*-*-*", 
			     &missing_list, &missing_count, &def_string );

	XFreeStringList( missing_list );   

	/* եȾμ */
	fs_extents = XExtentsOfFontSet(fs);

	font_w  = fs_extents->max_logical_extent.width;
	font_h  = fs_extents->max_logical_extent.height;
	ascent  = - fs_extents->max_logical_extent.y;
	descent = fs_extents->max_logical_extent.height - ascent;

	/* 
	 * ɥȹ⤵ 
	 * IM ξΰ褪Խΰݤ뤿ᡢ
	 * xim_root.c  2 ʬ⤵򹭤 
	 */
	win_w = font_w * COL;
	win_h = font_h * ( ROW + 2 );
}


static void 
xim_create_window( void )
{
	win = XCreateSimpleWindow( dpy, root,
		   0, 0, win_w, win_h, BORDER, black, white );

	gc = XCreateGC( dpy, win, 0, NULL );
	XSetBackground( dpy, gc, white );
	XSetForeground( dpy, gc, black );
}


static int 
xim_init_inputmethod( void )
{
	/* Խΰ褪Ӿΰؤ */
	XRectangle    preedit_rect, status_rect;

	/* Խΰ褪Ӿΰ°ꤹ뤿Υꥹ */
	XVaNestedList preedit_attr, status_attr;

	/* ץåȥ᥽åɤ򥪡ץ󤹤 */
	if ( ( im = XOpenIM( dpy, NULL, NULL, NULL ) ) == NULL ) {
		printf( "Couldn't open input method.\n" );
		return -1;
	}

	/* Խΰ° */
	preedit_rect.x      = 0;
	preedit_rect.y      = font_h * ROW;
	preedit_rect.width  = win_w;
	preedit_rect.height = font_h;

	preedit_attr  = XVaCreateNestedList( 
		( int )NULL, XNArea, &preedit_rect, XNFontSet, fs, NULL );

	status_rect.x       = 0;
	status_rect.y       = font_h * ( ROW + 1 );
	status_rect.width   = win_w;
	status_rect.height  = font_h;

	status_attr = XVaCreateNestedList( 
		( int )NULL, XNArea, &status_rect, XNFontSet, fs, NULL );

	/* ץåȥƥȤκ */
	ic = XCreateIC( im,
			XNInputStyle,        
			XIMPreeditArea | XIMStatusArea,
			XNClientWindow,      
			win,
			XNPreeditAttributes, 
			preedit_attr,
			XNStatusAttributes,  
			status_attr,
			NULL );

	XFree( preedit_attr );
	XFree( status_attr );

	if ( ic == NULL ) {
		printf( "Couldn't create input context.\n" );
		XCloseIM( im );
		return -1;
	}

	return 0;
}


static void 
xim_event_loop( void )
{
	XEvent event;

	while( 1 ) {
		XNextEvent( dpy, &event );

		/* ץåȥ᥽åɤ˥٥ȤϤ */
		if( XFilterEvent( &event, ( Window )NULL ) == True ) {
			/* ٥Ȥϥե륿󥰤줿 */
			continue;
		}

		switch( event.type ) {
			/* 
			 * Expose ٥ȤѰդƤʤΤǡɥ
			 * 줿ʤɤˤƤϼ롣
			 */
			case KeyPress :
				xim_draw( &event );
				break;

			case FocusIn :
				XSetICFocus( ic );
				break;

			case FocusOut:
				XUnsetICFocus( ic );
				break;

			case ClientMessage:
				if ( event.xclient.data.l[0] == protocol ) {
					return;
				}
				break;
		}
	}
}


static void
xim_draw( XEvent* event )
{
	Status status;
	KeySym keysym;
	int    cnt = 0;

	/* COL  2 Хʸʬΰ 1 ԤκʸȤ */
	char   buffer[ COL * 2 ];

	static int row = 0;
	static int col = 0;


	/* ʸμ */
	cnt = XmbLookupString( ic, ( XKeyPressedEvent* )event,
			       buffer, sizeof( buffer ), &keysym, &status );


	/* 
	 * βԽ򲼤 if ʸ˹Ԥʤȡ˥٥
	 * 򽦤ƲԽԤʤΤ 
	 */
	if ( status == XLookupBoth && keysym == XK_Return ) {
		/* ǲʤã顢ƬԤ */
		if ( ++ row >= ROW ) {
			row = 0; 
		}
		col = 0;

		/* Ԥ򥯥ꥢ */
		XClearArea( dpy, win, 0, font_h * row, win_w, font_h, False );
	}
	else if ( status == XLookupChars || status == XLookupBoth ) {
		/* 
		 * ʸ(ʸ) 
		 *
		 * 踶 x ɸݤˡfont_w / 2 Ȥ׻
		 * Ƥ뤬 1 Хʸ롣ܸ
		 * ʸ(ʸ)Ϥ줿ˤ 2 ХȤ char 
		 * ͤΤǡߤ col  font_w / 2 򤫤
		 * 褹٤踶 x ɸǤ롣
		 */

		XmbDrawString( dpy, win, fs, gc,
			       ( font_w / 2 ) * col, font_h * row + ascent,
			       buffer, cnt );

		col += cnt;
	}

	/* 
	 * status  XBufferOverflow ξϡѰդХåեʸ
	 * ǼʤäȤȤʤΤǡξϽʬʥХå
	 * ѰդǺ XmbLookupString() ¹Ԥɬפ롣
	 */
}


static void 
xim_close( void )
{
	printf( "Exit application.\n" );

	XDestroyIC( ic );
	XCloseIM( im );
	XFreeGC( dpy, gc );
	XDestroyWindow( dpy, win );
	XCloseDisplay( dpy );
}


/* End of xim_offspot.c */
