#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <time.h>


#define WIN_W  400   /* ɥ   */
#define WIN_H  300   /* ɥι⤵ */
#define WIN_X  100   /* ɥɽ(X) */
#define WIN_Y  100   /* ɥɽ(Y) */
#define BORDER 2     /* ܡ      */


static  Display*       dpy;            /* ǥץ쥤 */
static  Window         root;           /* 롼ȥɥ */
static  Window         win;            /* ɽ륦ɥ */
static  int            screen;         /* ꡼ */
static  int            depth;          /* ꡼ο */
static  XVisualInfo    visual_info;    /* ӥ奢 */
static  Colormap       cmap;           /* 顼ޥå */
static  unsigned long  color_pixel;    /* ؤ˻Ѥԥ */
static  XColor         color[2];       /* ؤ˻Ȥ( RGB ) */


static void xblink_init( void );
static int  xblink_check_visual( void );
static void xblink_create_window( void );
static int  xblink_alloc_color( void );
static void xblink_event_loop( void );


int 
main( void )
{
	xblink_init();

	/* ӥ奢å */
	if ( xblink_check_visual() == -1 ) {
		return 1;
	}

	/* ɤ߽ξѥ顼ơꤹ */
	if ( xblink_alloc_color() == -1 ) {
		return 1;
	}

	xblink_create_window();
	XMapWindow( dpy, win );
	xblink_event_loop();

	return 0;
}


static void 
xblink_init( void )
{
	dpy = XOpenDisplay( "" );

	root   = DefaultRootWindow( dpy );
	screen = DefaultScreen( dpy );
	depth  = DefaultDepth( dpy, screen );
	cmap   = DefaultColormap( dpy, screen );
}


/*
 * PseudoColor ⤷ DirectColor Υӥ奢
 * ݡȤƤ뤫ɤå롣
 */
static int
xblink_check_visual( void )
{ 
	/* XAllocColorCells() Τˡɤ߽ξѤΥӥ奢뤬
	   ݡȤƤ뤫ɤå */
	if ( ! XMatchVisualInfo( dpy, screen, depth, PseudoColor, &visual_info ) ) {
		printf( "Writable visual class is not supported.\n" );
		return -1;
	}

	return 0;
}


/*
 * ɤ߽ξѤΥ顼 1 ĳݤɽꤷƤ
 */
static int
xblink_alloc_color( void )
{
	unsigned long b_pixel[1], p_mask[1];
	int i;

	/* ؤѤˡɤ߽ξѤΥ顼 1 ĳƤ */
	if ( XAllocColorCells( dpy, cmap, True, p_mask, 0, b_pixel, 1 ) == 0 ) {
		printf( "XAllocColorCells() failed\n" );
		return -1;
	}

	/* b_pixel[0] ˥ԥͤǼƤ롣xblink.c Ǥ p_mask ˰̵̣ */
	color_pixel = b_pixel[0];

	if ( ! XParseColor( dpy, cmap, "red",   &color[0] ) ) {
		printf( "XParseColor() for red failed\n" );
		return -1;
	}

	if ( ! XParseColor( dpy, cmap, "black", &color[1] ) ) {
		printf( "XParseColor() for black failed\n" );
		return -1;
	}

	for ( i = 0; i < 2; i ++ ) {
		color[i].pixel = color_pixel;
		color[i].flags = DoRed | DoGreen | DoBlue;
	}

	/* ɽֿ */
	XStoreColor( dpy, cmap, &color[0] );
	return 0;
}


/*
 * ɥκ / եåƥȤκԤ
 */
static void 
xblink_create_window( void )
{
	/* ɥ롣λǤϤޤ̤ɽʤ*/
	win = XCreateSimpleWindow( dpy, root, 
				   WIN_X, WIN_Y, WIN_W, WIN_H, BORDER, 
				   color_pixel, color_pixel );

	XSelectInput( dpy, win, KeyPressMask );
}


static void 
xblink_event_loop( void )
{
	/* ߤɽ򼨤ǥå */
	int  current_col = 0;

	/* Ǹɽؤ */
	time_t previous = time( NULL );

	time_t now;  /* ߻ */
	XEvent evt;  /* ٥ȹ¤ѿ */

	while( 1 ) {
		/*
		 * ޤɽڤؤԤäƤ顢٥
		 * νԤ( ɤ餬ǤɤΤ)
		 */ 

		now = time( NULL );

		/* ؤ 1 ÷вᤷƤ顢ɽؤ */
		if ( now - previous >= 1 ) {
			if ( current_col == 0 ) {
				current_col ++;
			}
			else {
				current_col = 0;
			}

			/* ɽؤ */
			XStoreColor( dpy, cmap, &color[ current_col ] );

			/* ؤ¸ */
			previous = now;
		}

		while ( XPending( dpy ) ) {
			XNextEvent( dpy, &evt );

			switch ( evt.type ) {
				case KeyPress:
					/* ꥽β */
					/*
					 *  XFreeColors( 
					 *      dpy, cmap, &color_pixel, 1, planes );
					 */
					XDestroyWindow( dpy, win );
					XCloseDisplay( dpy );
					return;
			}
		}
	}
}


/* End of xblink.c */
