#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define WIN_X   100  /* ɥɽ(X) */
#define WIN_Y   100  /* ɥɽ(Y) */


/* DIB եβǼ빽¤ */
typedef struct _DIBImage_t
{
    int            width;           /*  */
    int            height;          /* ι⤵ */
    int            n_color;         /* ο */
    unsigned char  palette[256][3]; /* ѥåȾ */
    unsigned char* data;            /* ԥǡ */
}
DIBImage;


static Display* dpy;        /* ǥץ쥤 */
static Window   root, win;  /* 롼ȥɥɽɥ */
static int      screen;     /* ꡼ */
static int      depth;      /* ꡼ο */
static Pixmap   pixmap;     /* ԥޥå */
static GC       gc;         /* եåƥ */
static XColor*  colors;     /* DIB եΥѥåȾǼΰ */


static int  xdib_readFile( char* fname, DIBImage* dib_image );
static void xdib_setup( DIBImage* dib_image );


int 
main( int argc, char** argv )
{
	XEvent   evt;
	DIBImage dib_image;


	/* ꤵ줿 DIB եɤ߹ǲ¸ */
	if ( xdib_readFile( argv[1], &dib_image ) == 0 ) {
		printf( "Failed to read specified DIB file : %s\n", argv[1] );
		return 1;
	}

	dpy = XOpenDisplay( "" );

	root   = DefaultRootWindow( dpy );
	screen = DefaultScreen( dpy );
	depth  = DefaultDepth( dpy, screen );

	/* depth  1632 ʳξϤǽλ */
	if ( depth != 16 && depth != 32 ) {
		XCloseDisplay( dpy );
		printf( "Screen depth is not 16 nor 32 bpp.\n" );
		return 1;
	}


	win = XCreateSimpleWindow( dpy, root, WIN_X, WIN_Y, 
				   dib_image.width,
				   dib_image.height,
				   0,
				   BlackPixel( dpy, screen ), 
				   BlackPixel( dpy, screen ) );

	gc = XCreateGC( dpy, win, 0, NULL );

	/* ɤ߹ DIB եɽǤ褦ꤹ */
	xdib_setup( &dib_image );

	XSelectInput( dpy, win, ExposureMask | KeyPressMask );
	XMapWindow( dpy, win );

	while( 1 ) {
		XNextEvent( dpy, &evt );

		switch( evt.type ) { 
			case Expose:
				if ( evt.xexpose.count == 0 ) {
					/* ԥޥåפ򥦥ɥ˥ԡ */
					XCopyArea( dpy, pixmap, win, gc, 
						   0, 0,
						   dib_image.width,
						   dib_image.height,
						   0, 0 );
					XFlush( dpy );
				}
				break;

			case KeyPress:
				free( colors );
				XFreePixmap( dpy, pixmap );
				XDestroyWindow( dpy, win );
				XCloseDisplay( dpy );
				return 0;
		}
	}
}


/* 
 * ꤷ DIB եɤ߹ߡ dib_image ѿ
 * ˳Ǽ롣ԥǡ¸뤿 dib_image.data 
 * ΰϴؿǳݤ롣ΤܴؿѤݤˤϡ
 * dib_image.data ̤ݤǤ dib_image ѿؤΥݥ󥿤
 * ˻ꤹ뤳ȡ
 * ɤ߹߽˼Ԥ 0 Ϥʳ֤ͤ
 */
static int 
xdib_readFile( char* fname, DIBImage* dib_image )
{
	unsigned char buf[4];    
	FILE* fp;
	int   i;
	int   dib_depth;
	int   offset;
	int   bw;
	int   index;


	if ( ( fp = fopen( fname, "r" ) ) == NULL ) {
		printf( "Failed to open %s.\n", fname );
		return 0;
	}


	/* Ƭ 2 ХȤ "BM" ǤСBMP ե */
	fread( buf, 2, 1, fp );

	if ( strncmp( ( char* )buf, "BM", 2 ) != 0 ) {
		printf( "Specified file is not DIB file.\n" );
		return 0;
	}


	/* եƬ 28 ХȤΰ֤˰ư */
	fseek( fp, 28, SEEK_SET );

	/* 1 ԥ뤢Υӥåȿ */
	fread( buf, 2, 1, fp );
	dib_depth = buf[0] + ( buf[1] << 8 );

	/* 256 ʲΥե뤬о */
	if ( dib_depth > 8 ) {
		printf( "Specified file is more than 8 bpp ( %d bpp ).\n", dib_depth );
		return 0;
	}


	/* եƬ 30 ХȤΰ֤˰ư */
	fseek( fp, 30, SEEK_SET );
	fread( buf, 4, 1, fp );

	/* ɤ߹ͤ 0 ǤʤСbiCompression  BI_RGB Ǥʤ
	   (ԥǡ̤Ƥ)Τǡǽλ롣*/

	if ( buf[0] != 0 ) {
		printf( "Specified DIB file is compressed\n" );
      		return 0;
	}


	/* եƬ 46 ХȤΰ֤˰ư */
	fseek( fp, 46, SEEK_SET );
	fread( buf, 4, 1, fp );

	/* ɤ߹ͤ 0 ǤʤСdepth ˤäƿޤ롣
	   256 ʲΥեǤ뤿ᡢǽ 1 ХȤΤߤͤɤ */
	if ( buf[0] == 0 ) {
		dib_image->n_color = 1 << dib_depth;
	}
	else {
		dib_image->n_color = buf[0];
	}


	/* եƬ 10 ХȤΰ֤˰ư */
	fseek( fp, 10, SEEK_SET );

	/* եƬԥǡΰƬޤǤΥեåȤ */
	fread( buf, 2, 1, fp );
	offset = buf[0] + ( buf[1] << 8 );


       	/* եƬ 18 ХȤΰ֤˰ư */
	fseek( fp, 18, SEEK_SET );

	/*  */
	fread( buf, 4, 1, fp );

	dib_image->width  = buf[0] + ( buf[1] << 8 ) + 
		( buf[2] << 16 ) + ( buf[3] << 24 );

	/* ι⤵ */
	fread( buf, 4, 1, fp );

	dib_image->height = buf[0] + ( buf[1] << 8 ) + 
		( buf[2] << 16 ) + ( buf[3] << 24 );

    
	/* եƬ 54 ХȤΰ֤˰ư */
	fseek( fp, 54, SEEK_SET );

	/* ѥåȾ */
	for ( i = 0; i < dib_image->n_color; i ++ ) {
		fread( buf, 4, 1, fp );
		dib_image->palette[i][0] = buf[2];
		dib_image->palette[i][1] = buf[1];
		dib_image->palette[i][2] = buf[0];
	}


	/*  1 ʬΥХȿϡ 1 ֶᤤ 4 ܿ˷夲 */
	bw = ( dib_image->width + 3 ) & ~3;


	/* ԥǡΰγ */
	dib_image->data = 
		( unsigned char* )malloc( dib_image->width * dib_image->height );

	for ( i = 0; i < dib_image->height; i ++ ) {
		/* ԥǡΰƬ 1 Ԥɤ߹ */
		fseek( fp, offset + bw * i, SEEK_SET );

		/* 
		 * DIB ΥԥǡϲԤ˵ͤƤ롣
		 * dib_image->data ˤϾԤ˵ͤ뤿ᡢб
		 * ǥå׻Ƥ롣
		 */
		index = dib_image->width * ( dib_image->height - i - 1 );

		/* 1 ɤ߹ */
		fread( &( dib_image->data[ index ] ), dib_image->width, 1, fp );
	}

	fclose( fp );
	return 1;
}


/*
 * ɤ߹ DIB եȤäơºݤ˥ɥ
 * ɽǤ褦Ԥ
 */
static void 
xdib_setup( DIBImage* dib_image )
{
	/* 
	 * ɤ߹ DIB եβ򥯥饤¦
	 * ݻ뤿 XImage ¤
	 */
	XImage*  ximage;

	/* 饤¦ X ФžԥǡǼΰ */
	unsigned char* img_data;  

	int size;
	int i;


	/* DIBImage ѿ˳Ǽ줿顼ѥåȾXColor ¤Τ
	   Ѵ */
	colors = ( XColor* )malloc( sizeof( XColor ) * dib_image->n_color );

	for ( i = 0; i < dib_image->n_color; i ++ ) {
		colors[i].red   = dib_image->palette[i][0] * 257;
		colors[i].green = dib_image->palette[i][1] * 257;
		colors[i].blue  = dib_image->palette[i][2] * 257;
		colors[i].flags = DoRed | DoGreen | DoBlue;

		XAllocColor( dpy, DefaultColormap( dpy, screen ), &colors[i] );
	}


	/* X ¦ǲݻ뤿Υԥޥåפ */
	pixmap = XCreatePixmap( dpy, win, 
				dib_image->width, 
				dib_image->height, 
				depth );


	/* ꡼ο˹碌žѥԥǡ */
	size     = dib_image->width * dib_image->height;
	img_data = ( unsigned char* )malloc( size * depth / 8 );

	memset( img_data, 0, size * depth / 8 );


	/* 
	 * DIBImage ΥԥǡϡѥåȾΤɤǤ
	 * ԥб뿧Ǥ뤫ɽƤ롣 žѤΥԥ
	 * ǡϡ ꡼οƱӥåȿɽ줿ƿ
	 * ԥͤǤʤФʤʤΤǡѴԤ
	 */
	for ( i = 0; i < size; i ++ ) {
		memcpy( img_data + i * ( depth / 8 ) , 
			&( colors[dib_image->data[i]].pixel ), depth / 8 );
	}


	/* 饤¦βݻΰǤ XImage ¤ѿ */
	ximage = XCreateImage( dpy, DefaultVisual( dpy, screen ),
			       depth, ZPixmap, 0, 
			       ( char* )img_data,
			       dib_image->width, 
			       dib_image->height,
			       /* 16 bpp ξ 1624 / 32 bpp ξ 32 ˤ */
			       ( depth == 16 ) ? 16 : 32, 
			       0 );

	/* ԥǡԥޥåפž */
	XPutImage( dpy, pixmap, gc, ximage, 
		   0, 0, 
		   0, 0, 
		   dib_image->width, 
		   dib_image->height );

	XFlush( dpy );
	XDestroyImage( ximage );
	free( dib_image->data );
}


/* End of xdib.c */
